/*******************************************************************************
 *  Copyright 2017 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *  
 *    http://www.apache.org/licenses/LICENSE-2.0
 *  
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.hl7282.hl7model.messages.query;

import cdac.medinfo.sdk.hl7282.baselibs.messages.AbstractQuery;
import cdac.medinfo.sdk.hl7282.baselibs.segments.DSC;
import cdac.medinfo.sdk.hl7282.baselibs.segments.QPD;
import cdac.medinfo.sdk.hl7282.baselibs.segments.RCP;
import cdac.medinfo.sdk.hl7282.baselibs.segments.SFT;
import cdac.medinfo.sdk.hl7282.baselibs.segments.UAC;
import cdac.medinfo.sdk.hl7282.commoninterface.ISegment;
import cdac.medinfo.sdk.hl7282.commoninterface.ISingleCollection;
import cdac.medinfo.sdk.hl7282.utils.EnumMessageCode;
import cdac.medinfo.sdk.hl7282.utils.EnumMessageStructure;
import cdac.medinfo.sdk.hl7282.utils.EnumSegments;
import cdac.medinfo.sdk.hl7282.utils.EnumTriggerEvent;
import cdac.medinfo.sdk.hl7282.utils.IMap;

/**
 * QBP_Z87 - Query Grammar (Event Z87).
 * This message is use to retrieve patient pharmacy dispense history information from the Server.
 * <p>Represents a QBP_Q11 message structure (see chapter 5.3.3.2). This structure contains the 
 * following elements: </p>
 * 0: MSH (Message Header) <b>SINGLE_COMPULSARY</b><br>
 * 1: SFT (Software Segment) <b>MULTIPLE_OPTIONAL</b><br>
 * 2: UAC (User Authentication Credential segment) <b>SINGLE_OPTIONAL</b><br> 
 * 3: QPD (Query Parameter Definition) <b>SINGLE_COMPULSARY</b><br>
 * 4: RCP (Response Control Parameter) <b>SINGLE_COMPULSARY</b><br>
 * 5: DSC (Continuation Pointer) <b>SINGLE_OPTIONAL</b><br>
 * This class provides mechanism to validate message against HL7 v 2.5 standard.
 * The class provides accessors & mutators for the elements mentioned above.
 * These elements can be easily populated & populated values can be easily retrieved.
 * The class has validate method which validates Message against HL7 v 2.5 standard.
 *
 * <p>Following is the step to create message<br>
 * Before that, respective Message Source and Message Recipient to be set on Message Factory.</p>
 * <p>QBP_Z87 objZ87 = (QBP_Z87)MessageFactory.createInstance().createSendSupportedMessage("QBP", "Z87");</p>
 */
public  final class QBP_Z87 extends AbstractQuery 
{



	/**
	 * Constructs the QBP_Z87 message.
	 */
	QBP_Z87(IMap objMessageMap)
	{
		super(objMessageMap, EnumMessageCode.QBP.getValue(), EnumTriggerEvent.Z87.getValue(), EnumMessageStructure.QBP_Q11.getValue());
	}

	/**
	 * Veifies whether message is Query.
	 * @return boolean
	 */
	public boolean isQuery()
	{
		return true;
	}

	/**
	 * Retrieves the Collection of Software Segments(SFT) present in this message.
	 * @return ISingleCollection<SFT> - Collection of Software Segments(SFT) present in this message.
	 */
	@SuppressWarnings("unchecked")
	public ISingleCollection<SFT> getSoftwareSegments()
	{
		ISingleCollection<?> objSegmentCollection = getSegment(EnumSegments.HL7_SEG_SFT);
		return (ISingleCollection<SFT>)objSegmentCollection;
	}

	/**
	 * Adds the Software Segment(SFT) to this message.
	 * @param objSFT Specified Software Segment(SFT) to be added in this messageto this message.
	 */
	public void addSoftwareSegment(SFT objSFT)
	{
		addSegment(EnumSegments.HL7_SEG_SFT, objSFT);
	}

	/**
	 * Adds the collection of Software Segment(SFT) to this message.
	 * @param objSFTSegmentCollection Collection of Software Segments to add in this message
	 */
	@SuppressWarnings("unchecked")
	public void addSoftwareSegment(ISingleCollection<SFT>  objSFTSegmentCollection)
	{
		ISingleCollection<?> objSegmentCollection =  objSFTSegmentCollection;
		addSegment(EnumSegments.HL7_SEG_SFT, (ISingleCollection<ISegment>)objSegmentCollection);
	}

	/**
	 * Retrieves User Authentication Credential(UAC) segment present in this message
	 * @return UAC - the User Authentication Credential Segment present in this message or null if unavailable. 
	 */
	public UAC getUserAuthenticationCredentialSegment()
	{
		ISingleCollection<ISegment> objSingleCollection = getSegment(EnumSegments.HL7_SEG_UAC);
		if(objSingleCollection != null)
			return (UAC)objSingleCollection.elementAt(0);
		return null;
	}
	
	/**
	 * Sets value of User Authentication Credential(UAC) segment  for this message, overwrites if already present.
	 * @param objUAC Specified UAC Segment
	 */
	public void setUserAuthenticationCredentialSegment(UAC objUAC)
	{
		setSegment(EnumSegments.HL7_SEG_UAC,objUAC);
	}
	
	/**
	 * Retrieves the Query Parameter Definition(QPD) Segment present in this message
	 * @return QPD - the Query Parameter Definition Segment present in this message or null if unavailable.
	 */
	public QPD getQueryParameterDefinitionSoftware()
	{
		ISingleCollection<ISegment> objSingleCollection = getSegment(EnumSegments.HL7_SEG_QPD);
		if(objSingleCollection != null)
			return (QPD)objSingleCollection.elementAt(0);
		return null;
	}

	/**
	 * Set the value of Query Parameter Definition Segment for this message,overwrites if already present.
	 * @param objQPD Specified Query Parameter Definition Segment 
	 */
	public void setQueryParameterDefinitionSegment(QPD objQPD)
	{
		setSegment(EnumSegments.HL7_SEG_QPD,objQPD);
	}

	/**
	 * Retrieves the Response Control Parameter(RCP) Segment present in this message
	 * @return RCP - the Response Control Parameter Segment present in this message or null if unavailable.
	 */
	public RCP getResponseControlParameterSoftwareSegment()
	{
		ISingleCollection<ISegment> objSingleCollection = getSegment(EnumSegments.HL7_SEG_RCP);
		if(objSingleCollection != null)
			return (RCP)objSingleCollection.elementAt(0);
		return null;
	}

	/**
	 * Set the value of Query Parameter Definition Segment for this message,overwrites if already present.
	 * @param objRCP Specified Response Control Parameter Segment 
	 */
	public void setResponseControlParameterSoftwareSegment(RCP objRCP)
	{
		setSegment(EnumSegments.HL7_SEG_RCP,objRCP);
	}

	/**
	 * Retrieves the Continuation Pointer(DSC) Segment present in this message
	 * @return DSC - the Continuation Pointer Segment present in this message or null if unavailable.
	 */
	public DSC getContinuationPointerSoftwareSegment()
	{
		ISingleCollection<ISegment> objSingleCollection = getSegment(EnumSegments.HL7_SEG_DSC);
		if(objSingleCollection != null)
			return (DSC)objSingleCollection.elementAt(0);
		return null;
	}

	/**
	 * Set the value of Continuation Pointer Segment for this message,overwrites if already present.
	 * @param objDSC Specified Continuation Pointer Segment 
	 */
	public void setContinuationPointerSoftwareSegment(DSC objDSC)
	{
		setSegment(EnumSegments.HL7_SEG_DSC,objDSC);
	}
}